(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-xkb")

;;; functions

(define *country-list* (make-cell '()))
(define *variant-list* (make-cell '()))

(define (init-default url storage lst)
  (let ((items (woo-list/name+label url)))
    (cell-set! storage items)
    (lst rows (map cdr items)
         current 0)))

(define (current-text lst storage)
  (let ((num (lst current)))
    (and (>= num 0)
         (car (list-ref (cell-ref storage) num)))))

(define (update-variant)
  (let ((item (current-text country *country-list*)))
    (and item
         (init-default (string-append "/xkb/avail_layout/" item "/avail_variant")
                       *variant-list*
                       variant))))

(define (write-variant)
  (let ((item (current-text variant *variant-list*)))
    (and item
         (woo-write "/xkb/avail_layout/any-country/" 'variant item))))


;;; ui

width 650
height 400


(gridbox columns "5;90;5"
         (spacer)
         (hbox (label (_ "Country")) (document:id country (combobox)))
         (spacer)

         (spacer)
         (document:id variant (listbox header (vector (_ "Available layouts"))))
         (spacer))

(hbox (document:id ok-button (button (_ "OK")))
      (document:id cancel-button (button (_ "Cancel"))))



;;; logic

(document:root (when loaded
                 (woo-catch/message
                  (thunk
                   (ok-button (when clicked
                                (woo-catch/message write-variant)
                                (document:end #t)))
                   (cancel-button (when clicked (document:end #f)))
                   (init-default "/xkb/avail_layout" *country-list* country)
                   (country (when selected (update-variant)))
                   (country selected)))))

