(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-xkb")


;;; functions

(define *model-list* (make-cell '()))
(define *grp-list* (make-cell '()))
(define *layout-list* (make-cell '()))

(define (default-index x lst)
  (or (list-index (lambda(y) (string=? (car y) x))
                  lst)
      0))

(define (init-default url storage lst def)
  (let ((items (woo-list/name+label url)))
    (cell-set! storage items)
    (lst rows (map cdr items)
         current (default-index def items))))

(define (current-text lst storage)
  (let ((num (lst current)))
    (and (>= num 0)
         (car (list-ref (cell-ref storage) num)))))

(define (update-layout)
  (let ((data (woo-read-first "/xkb")))
    (init-default "/xkb/current_layout"
                  *layout-list*
                  layout
                  (woo-get-option data 'layout))))
                
(define (do- action)
  (let ((item (current-text layout *layout-list*)))
    (and item
         (woo-write "/xkb" action #t  'layout item)
         (update-layout))))

(define (do-up) (do- 'up))
(define (do-down) (do- 'down))
(define (do-remove) (do- 'remove))

(define (do-add)
  (and (document:popup "/xkb/avail_layout")
       (update-layout)))

(define (do-apply)
  (let ((grp-text (current-text grp *grp-list*))
        (model-text (current-text model *model-list*)))
    (and grp-text
         model-text
         (woo-write "/xkb"
                    'submit #t
                    'update #t
                    'grp grp-text
                    'model model-text))))

;;; ui

(gridbox columns "10;80;10"
         (spacer)
         (hbox (label (_ "Model")) (document:id model (combobox)))
         (spacer)

         (spacer)
         (document:id layout (listbox header (vector (_ "Layouts"))))
         (spacer)

         (spacer)
         (hbox
          (document:id add-button (button (_ "Add") align "left"))
          (document:id remove-button (button (_ "Remove") align "left"))
	  (spacer)
          (document:id up-button (button (_ "Up") align "right"))
          (document:id down-button (button (_ "Down") align "right")))
         (spacer)

         (spacer)
	 (label "")
	 (spacer)

         (spacer)
         (hbox (label (_ "Layout switching")) (document:id grp (combobox)))
         (spacer))

(hbox (document:id apply-button (button (_ "Apply")))
      (document:id quit-button (button (_ "Quit"))))

;;; logic

(document:root (when loaded
                 (woo-catch/message
                  (thunk
                   (let ((data (woo-read-first "/xkb")))
                     (init-default "/xkb/avail_model"
                                   *model-list*
                                   model
                                   (woo-get-option data 'model))
                     (init-default "/xkb/avail_grp"
                                   *grp-list*
                                   grp
                                   (woo-get-option data 'grp))
                     (init-default "/xkb/current_layout"
                                   *layout-list*
                                   layout
                                   (woo-get-option data 'layout))
                     (up-button (when clicked (woo-catch/message do-up)))
                     (down-button (when clicked (woo-catch/message do-down)))
                     (add-button (when clicked (woo-catch/message do-add)))
                     (remove-button (when clicked (woo-catch/message do-remove)))
                     (apply-button (when clicked (woo-catch/message do-apply)))
                     (quit-button (when clicked (document:end))) )))))
